function [A,B] = eulerLagrangeDiscrete(N,k_x)

    A = zeros(N);
    B = zeros(N);
    
    % Use symbolic functions to facilitate differentiation of ubar.
    syms z;
    %ubarFun = z; % Eady
    %ubarFun = -(1/2)*(1 - 6*z^2 + 4*z^3); % Philips
    ubarFun = z^2/2; % Charney

    Sfun = 1;
    dzUbarFun = diff(ubarFun);
    dzSdzUbarFun = diff(Sfun*dzUbarFun);
    
    % Convert symbolic functions into function handles for ease of use
    % below.
    S = @(x) subs(Sfun,z,x);
    dzUbar = @(x) subs(dzUbarFun,z,x);
    dzSdzUbar = @(x) subs(dzSdzUbarFun,z,x);

    zN = linspace(0,1,N);
    dz = 1/(N-1);

    D1 = (diag(ones(N-1,1),1) - diag(ones(N-1,1),-1))/(2*dz);
    fluxStencilInterior = ...
        ([zeros(N-2,1), -diag(S(zN(1:N-2)+dz/2)+S(zN(2:N-1)+dz/2)), zeros(N-2,1)] + ...
        [zeros(N-2,2),diag(S(zN(1:N-2)+dz/2))] + ...
        [diag(S(zN(2:N-1)+dz/2)),zeros(N-2,2)])/dz^2;

    % Build interior
    tmp = -1i*diag(dzSdzUbar(zN)) - 2*1i*k_x*diag(S(zN).*dzUbar(zN))*D1;
    A(2:N-1,:) = tmp(2:N-1,:);
    
    tmp = k_x^2*[zeros(N-2,1),eye(N-2),zeros(N-2,1)] - ...
            fluxStencilInterior;
    B(2:N-1,:) = tmp;

    % Lower Boundary
    A(1,1) = -1i*k_x*S(0)*dzUbar(0);
    B(1,1) = S(0)/dz;
    B(1,2) =-S(0)/dz;

    % Upper Boundary
    A(N,N) = -1i*k_x*S(1)*dzUbar(1);
    B(N,N) = -S(1)/dz;
    B(N,N-1) = S(1)/dz;

end

